Index: /trunk/Softwares/Basic_test/src/asm/asm_013_sfltu.s
===================================================================
--- /trunk/Softwares/Basic_test/src/asm/asm_013_sfltu.s	(revision 88)
+++ /trunk/Softwares/Basic_test/src/asm/asm_013_sfltu.s	(revision 88)
@@ -0,0 +1,220 @@
+/********************************************
+ * files               : asm_013_sfltu.s
+ * authors             : Rosiere Mathieu
+ * date                : 2006/06/22
+ ********************************************
+ * input               : -
+ * output              : 1 test OK
+ *                       0 test KO
+ ********************************************
+ * test                : test l.sfltu
+ * warning             : instruction ok 
+ *                         l.addi
+ *                         l.and
+ *                         l.bf
+ *                         l.bnf
+ *                         l.movhi
+ *                         l.jal
+ *                         l.jr
+ *		           l.lwz
+ *                         l.ori
+ *                         l.sw
+ ********************************************
+ */
+	.file	"asm_013_sfltu.s"
+	.section .text
+	.align	4
+
+	.global _asm_013_sfltu
+_asm_013_sfltu :	
+	/* save context */
+	l.addi	r1,r1,-8
+	l.sw	0 (r1),r21
+	l.sw	4 (r1),r22
+	/* Return is KO (default)*/
+	l.and   r11,r0,r0
+
+	/* Listing of test
+			|	R	I	I
+	Op1	Op2	|	F1	F2	F3
+	----------------+-------------------------------
+	+	+=	|	0	0	0
+	+	+>	|	1	0	1
+	+	+<	|	0	0	0
+	+	-	|	1	1	1
+	-	-=	|	0	0	1
+	-	->	|	1	1	1
+	-	-<	|	0	0	1
+
+	Op1 with :
+	Value on 32 bits		(result F1)
+	Value on 16 bits - extend 1	(result F2)
+	                 - extend 0	(result F3)
+	 */
+
+	/*************************/
+	/* F1 :	VALUE ON 32 BITS */
+	/*************************/
+	
+	/* Op1 : + */
+	l.movhi	r21,0x7ead
+	l.ori   r21,r21,0xbeaf
+
+	/* Op2 : += */
+	l.movhi	r22,0x7ead
+	l.ori   r22,r22,0xbeaf
+	
+	l.sfltu	r21,r22
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	1
+
+	/* Op2 : +> */
+	l.movhi	r22,0x7ead
+	l.ori   r22,r22,0xbfaf
+
+	l.sfltu	r21,r22
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	2
+	
+	/* Op2 : +< */
+	l.movhi	r22,0x7ead
+	l.ori   r22,r22,0xbdaf
+
+	l.sfltu	r21,r22
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	3
+
+	/* Op2 : - */
+	l.movhi	r22,0xdead
+	l.ori   r22,r22,0xbeaf
+
+	l.sfltu	r21,r22
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	4
+	
+	/* Op1 : - */
+	l.movhi	r21,0xdead
+	l.ori   r21,r21,0xbeaf
+
+	/* Op2 : -= */
+		
+	l.sfltu	r21,r22
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	5
+
+	/* Op2 : -> */
+	l.movhi	r22,0xdead
+	l.ori   r22,r22,0xbfaf
+
+	l.sfltu	r21,r22
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	6
+	
+	/* Op2 : -< */
+	l.movhi	r22,0xdead
+	l.ori   r22,r22,0xbdaf
+
+	l.sfltu	r21,r22
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	7
+
+	/************************************/
+	/* F2 :	VALUE ON 16 BITS - extend 1 */
+	/************************************/
+	/* Op1 : + */
+	l.movhi	r21,0xFFFF
+	l.ori   r21,r21,0x7ead
+
+	/* Op2 : += */
+	l.sfltui	r21,0x7ead
+	l.bf 	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	1
+
+	/* Op2 : +> */
+	l.sfltui	r21,0x7ebd
+	l.bf 	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	2
+	
+	/* Op2 : +< */
+	l.sfltui	r21,0x7e9d
+	l.bf 	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	3
+
+	/* Op2 : - */
+	l.sfltui	r21,0xdead
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	4
+	
+	/* Op1 : - */
+	l.movhi	r21,0xFFFF
+	l.ori   r21,r21,0xdead
+
+	/* Op2 : -= */
+	l.sfltui	r21,0xdead
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	5
+
+	/* Op2 : -> */
+	l.sfltui	r21,0xdebd
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	6
+	
+	/* Op2 : -< */
+	l.sfltui	r21,0xde9d
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	7
+	
+	/************************************/
+	/* F3 :	VALUE ON 16 BITS - extend 0 */
+	/************************************/
+	/* Op1 : + */
+	l.movhi	r21,0x0000
+	l.ori   r21,r21,0x7ead
+
+	/* Op2 : += */
+	l.sfltui	r21,0x7ead
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	1
+
+	/* Op2 : +> */
+	l.sfltui	r21,0x7ebd
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	2
+	
+	/* Op2 : +< */
+	l.sfltui	r21,0x7e9d
+	l.bf	_asm_013_sfltu_ko	/* if     set :	error */
+	l.nop	3
+
+	/* Op2 : - */
+	l.sfltui	r21,0xdead
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	4
+	
+	/* Op1 : - */
+	l.movhi	r21,0x0000
+	l.ori   r21,r21,0xdead
+
+	/* Op2 : -= */
+	l.sfltui	r21,0xdead
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	5
+
+	/* Op2 : -> */
+	l.sfltui	r21,0xdebd
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	6
+	
+	/* Op2 : -< */
+	l.sfltui	r21,0xde9d
+	l.bnf	_asm_013_sfltu_ko	/* if not set :	error */
+	l.nop	7
+					
+_asm_013_sfltu_ok :	
+	l.addi	r11,r0,1
+_asm_013_sfltu_ko :	
+	/* load context */
+	l.lwz	r22,4 (r1)
+	l.lwz	r21,0 (r1)
+	l.jr	r9
+	l.addi	r1,r1,8
Index: /trunk/Softwares/Basic_test/src/asm/asm_014_cmov.s
===================================================================
--- /trunk/Softwares/Basic_test/src/asm/asm_014_cmov.s	(revision 88)
+++ /trunk/Softwares/Basic_test/src/asm/asm_014_cmov.s	(revision 88)
@@ -0,0 +1,69 @@
+/********************************************
+ * files               : asm_014_cmov.s
+ * authors             : Rosiere Mathieu
+ * date                : 2006/06/20
+ ********************************************
+ * input               : -
+ * output              : 1 test OK
+ *                       0 test KO
+ ********************************************
+ * test                :
+ * warning             : instruction ok 
+ *                         l.addi
+ *                         l.and
+ *                         l.jal
+ *                         l.jr
+ *			   l.lwz
+ *                         l.or
+ *                         l.ori
+ *			   l.sfeq
+ *			   l.sw
+ ********************************************
+ */
+	.file	"asm_014_cmov.s"
+	.section .text
+	.align	4
+
+	.global _asm_014_cmov
+_asm_014_cmov :	
+	/* save context */
+	l.addi	r1,r1,-16
+	l.sw	0 (r1),r20
+	l.sw	4 (r1),r21
+	l.sw	8 (r1),r22
+	l.sw	12(r1),r23	
+	/* Return is KO (default)*/
+	l.and   r11,r0,r0
+
+	l.and	r20,r0,r0
+	l.movhi	r21,0x5555
+	l.ori	r21,r21,0x5555
+	l.movhi	r22,0xaaaa
+	l.ori	r22,r22,0xaaaa
+
+	/* set flag 1 */
+	l.sfeq	r0,r0
+	l.cmov	r20,r21,r0
+
+	/* set flag 0 */
+	l.sfne	r0,r0
+	l.cmov	r23,r0,r22
+
+	l.or	r20,r20,r23
+	
+	l.sfeqi	r20,-1
+	l.bnf	_asm_014_cmov_ko
+	l.nop	0
+	
+_asm_014_cmov_ok :	
+	l.addi	r11,r0,1
+_asm_014_cmov_ko :
+	
+	/* load context */
+	l.lwz	r23,12(r1)
+	l.lwz	r22,8 (r1)
+	l.lwz	r21,4 (r1)
+	l.lwz	r20,0 (r1)
+	l.jr	r9
+	l.addi	r1,r1,16
+	
Index: /trunk/Softwares/Basic_test/src/asm/asm_015_shift_rotate.s
===================================================================
--- /trunk/Softwares/Basic_test/src/asm/asm_015_shift_rotate.s	(revision 88)
+++ /trunk/Softwares/Basic_test/src/asm/asm_015_shift_rotate.s	(revision 88)
@@ -0,0 +1,214 @@
+/********************************************
+ * files               : asm_015_shift_rotate.s
+ * authors             : Rosiere Mathieu
+ * date                : 2006/06/20
+ ********************************************
+ * input               : -
+ * output              : 1 test OK
+ *                       0 test KO
+ ********************************************
+ * test                :
+ * warning             : instruction ok 
+ *                         l.addi
+ *                         l.and
+ *                         l.bnf
+ *                         l.jal
+ *                         l.jr
+ *                         l.movhi
+ *                         l.ori
+ *                         l.sfeq
+ ********************************************
+ */
+	.file	"asm_015_shift_rotate.s"
+	.section .text
+	.align	4
+
+	.global _asm_015_shift_rotate
+_asm_015_shift_rotate :	
+	/* save context */
+	l.addi	r1,r1,-16
+	l.sw	0 (r1),r20
+	l.sw	4 (r1),r21
+	l.sw	8 (r1),r22
+	l.sw	12(r1),r23
+	
+	/* Return is KO (default)*/
+	l.and   r11,r0,r0
+
+	l.movhi	r20, 0x2b3c
+	l.ori	r20,r20,0x4d1a
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+	l.rori	r22,r21, 4
+	l.rori	r22,r22, 2
+	l.rori	r22,r22, 0
+	l.rori	r22,r22, 3
+	l.rori	r22,r22, 5
+	l.rori	r22,r22, 7
+	l.rori	r22,r22, 3
+
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+	
+	l.ori 	r23,r0,1
+	l.ror	r22,r21,r23
+	l.and	r23,r0,r0
+	l.ror	r22,r22,r23		
+	l.ori	r23,r0,5
+	l.ror	r22,r22,r23		
+	l.ori 	r23,r0,2
+	l.ror	r22,r22,r23		
+	l.ori 	r23,r0,5
+	l.ror	r22,r22,r23		
+	l.ori	r23,r0,3
+	l.ror	r22,r22,r23
+	l.ori	r23,r0,8
+	l.ror	r22,r22,r23	
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	2
+
+	l.movhi	r20, 0x4d00
+	l.ori	r20,r20,0x0000
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.slli	r22,r21,4
+	l.slli	r22,r22,0
+	l.slli	r22,r22,10
+	l.slli	r22,r22,7 	
+	l.slli	r22,r22,3 
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.ori	r23,r0,4
+	l.sll 	r22,r21,r23
+	l.ori	r23,r0,0	
+	l.sll 	r22,r22,r23
+	l.ori	r23,r0,10
+	l.sll 	r22,r22,r23
+	l.ori	r23,r0,7
+	l.sll 	r22,r22,r23	
+	l.ori	r23,r0,3
+	l.sll 	r22,r22,r23
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+
+	l.movhi	r20, 0x0000
+	l.ori	r20,r20,0x001a
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.srli	r22,r21,4
+	l.srli	r22,r22,0
+	l.srli	r22,r22,10
+	l.srli	r22,r22,7 	
+	l.srli	r22,r22,3 
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.ori	r23,r0,4
+	l.srl 	r22,r21,r23
+	l.ori	r23,r0,0	
+	l.srl 	r22,r22,r23
+	l.ori	r23,r0,10
+	l.srl 	r22,r22,r23
+	l.ori	r23,r0,7
+	l.srl 	r22,r22,r23	
+	l.ori	r23,r0,3
+	l.srl 	r22,r22,r23
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+
+	l.movhi	r20, 0x0000
+	l.ori	r20,r20,0x001a
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.srai	r22,r21,4
+	l.srai	r22,r22,0
+	l.srai	r22,r22,10
+	l.srai	r22,r22,7 	
+	l.srai	r22,r22,3 
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+
+	l.movhi	r21, 0x1a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.ori	r23,r0,4
+	l.sra 	r22,r21,r23
+	l.ori	r23,r0,0	
+	l.sra 	r22,r22,r23
+	l.ori	r23,r0,10
+	l.sra 	r22,r22,r23
+	l.ori	r23,r0,7
+	l.sra 	r22,r22,r23	
+	l.ori	r23,r0,3
+	l.sra 	r22,r22,r23
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+	
+	l.movhi	r20, 0xffff
+	l.ori	r20,r20,0xff8a
+
+	l.movhi	r21, 0x8a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.srai	r22,r21,4
+	l.srai	r22,r22,0
+	l.srai	r22,r22,10
+	l.srai	r22,r22,7 	
+	l.srai	r22,r22,3 
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+
+	l.movhi	r21, 0x8a2b
+	l.ori	r21,r21,0x3c4d
+
+	l.ori	r23,r0,4
+	l.sra 	r22,r21,r23
+	l.ori	r23,r0,0	
+	l.sra 	r22,r22,r23
+	l.ori	r23,r0,10
+	l.sra 	r22,r22,r23
+	l.ori	r23,r0,7
+	l.sra 	r22,r22,r23	
+	l.ori	r23,r0,3
+	l.sra 	r22,r22,r23
+	l.sfeq	r20,r22
+	l.bnf	_asm_015_shift_rotate_ko
+	l.nop	1
+		
+_asm_015_shift_rotate_ok :	
+	l.addi	r11,r0,1
+_asm_015_shift_rotate_ko :
+	
+	/* load context */
+	l.lwz	r23,12(r1)
+	l.lwz	r22,8 (r1)
+	l.lwz	r21,4 (r1)
+	l.lwz	r20,0 (r1)
+	l.jr	r9
+	l.addi	r1,r1,16
Index: /trunk/Softwares/Basic_test/src/asm/asm_016_load.s
===================================================================
--- /trunk/Softwares/Basic_test/src/asm/asm_016_load.s	(revision 88)
+++ /trunk/Softwares/Basic_test/src/asm/asm_016_load.s	(revision 88)
@@ -0,0 +1,150 @@
+/********************************************
+ * files               : asm_016_load.s
+ * authors             : Rosiere Mathieu
+ * date                : 2006/06/20
+ ********************************************
+ * input               : -
+ * output              : 1 test OK
+ *                       0 test KO
+ ********************************************
+ * test                :
+ * warning             : instruction ok 
+ *                         l.addi
+ *                         l.and
+ *                         l.bf
+ *                         l.jal
+ *                         l.jr
+ *			   l.sw
+ ********************************************
+ */
+	.file	"asm_016_load.s"
+	.section .text
+	.align	4
+
+	.global _asm_016_load
+_asm_016_load :	
+	/* save context */
+	l.addi	r1,r1,-16
+	/*      0 (r1) is reserved */
+	l.sw	4 (r1),r20
+	l.sw	8 (r1),r21
+	l.sw	12(r1),r22
+
+	/* Return is KO (default)*/
+	l.and   r11,r0,r0
+
+	/* Value Not Signed */
+ 	l.movhi	r20,0x1234
+	l.ori	r20,r20,0x5678
+		
+	/* TEST BYTES */
+	l.sb	0 (r1), r20
+	l.lbz	r21, 0 (r1)
+	l.extbz	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	l.lbs	r21, 0 (r1)
+	l.extbs	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	/* TEST HALF WORD */
+	l.sh	0 (r1), r20
+	l.lhz	r21, 0 (r1)
+	l.exthz	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	l.lhs	r21, 0 (r1)
+	l.exths	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	/* TEST WORD */
+	l.sw	0 (r1), r20
+	l.lwz	r21, 0 (r1)
+	l.extwz	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	l.lws	r21, 0 (r1)
+	l.extws	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	/* Value Signed */
+ 	l.movhi	r20,0xdead
+	l.ori	r20,r20,0xbeaf
+		
+	/* TEST BYTES */
+	l.sb	0 (r1), r20
+	l.lbz	r21, 0 (r1)
+	l.extbz	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	l.lbs	r21, 0 (r1)
+	l.extbs	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	/* TEST HALF WORD */
+	l.sh	0 (r1), r20
+	l.lhz	r21, 0 (r1)
+	l.exthz	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	l.lhs	r21, 0 (r1)
+	l.exths	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	/* TEST WORD */
+	l.sw	0 (r1), r20
+	l.lwz	r21, 0 (r1)
+	l.extwz	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+
+	l.lws	r21, 0 (r1)
+	l.extws	r22,r20
+
+	l.sfeq	r21,r22
+	l.bnf	_asm_016_load_ko
+	l.nop	1
+			
+_asm_016_load_ok :	
+	l.addi	r11,r0,1
+_asm_016_load_ko :
+	
+	/* load context */
+	l.lwz	r22,12(r1)
+	l.lwz	r21,8 (r1)
+	l.lwz	r20,4 (r1)
+	/*          0 (r1) is reserved */	
+	l.jr	r9
+	l.addi	r1,r1,16
Index: /trunk/Softwares/Basic_test/src/asm/asm_017_mul.s
===================================================================
--- /trunk/Softwares/Basic_test/src/asm/asm_017_mul.s	(revision 88)
+++ /trunk/Softwares/Basic_test/src/asm/asm_017_mul.s	(revision 88)
@@ -0,0 +1,341 @@
+/********************************************
+ * files               : asm_017_mul.s
+ * authors             : Rosiere Mathieu
+ * date                : 2006/06/20
+ ********************************************
+ * input               : -
+ * output              : 1 test OK
+ *                       0 test KO
+ ********************************************
+ * test                :
+ * warning             : instruction ok 
+ *                         l.addi
+ *                         l.and
+ *                         l.jal
+ *                         l.jr
+ ********************************************
+ */
+	.file	"asm_017_mul.s"
+	.section .text
+	.align	4
+
+	.global _asm_017_mul
+_asm_017_mul :	
+	/* save context */
+	l.addi	r1,r1,-16
+	l.sw	0 (r1),r20
+	l.sw	4 (r1),r21	
+	l.sw	8 (r1),r22
+	l.sw	12(r1),r23
+	
+	/* Return is KO (default)*/
+	l.and   r11,r0,r0
+
+	/*
+	 r20 :	result
+	 r21 :	operand 1
+	 r22 :	operand 2
+	 r23 :	result waited
+	*/
+	
+	/* Operand 1 : positive */
+	l.movhi r21,0x1234
+	l.ori	r21,r21,0x5678
+
+	/* Test 1.1 */
+	l.and	r22,r0,r0
+	l.and	r23,r0,r0
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,0
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 1.2 */
+		
+	l.ori	r22,r0,1
+	l.or 	r23,r0,r21
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,1
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 1.3 */
+		
+	l.ori	r22,r0,2
+	l.slli	r23,r21, 1
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,2
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 1.4 */
+		
+	l.ori	r22,r0,0x11
+	l.movhi r23,0x3579
+	l.ori	r23,r23,0xbdf8
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,0x11
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 1.4 */
+
+	l.addi	r22,r0,-1
+	l.movhi r23,0xedcb
+	l.ori	r23,r23,0xa988
+
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+/*
+	l.muli	r20,r21,-1
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+*/
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 1.5 */
+
+	l.addi	r22,r0,-2
+	
+	l.movhi r23,0xdb97
+	l.ori	r23,r23,0x5310
+
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+/*
+	l.muli	r20,r21,-2
+			
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+*/
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Operand 2 : negative */
+	l.movhi r21,0xdead
+	l.ori	r21,r21,0xbeaf
+
+	/* Test 2.1 */
+	l.and	r22,r0,r0
+	l.and	r23,r0,r0
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,0
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 2.2 */
+		
+	l.ori	r22,r0,1
+	l.or 	r23,r0,r21
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,1
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 2.3 */
+		
+	l.ori	r22,r0,2
+	l.slli	r23,r21, 1
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,2
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 2.4 */
+		
+	l.ori	r22,r0,0x11
+	l.movhi r23,0xc989
+	l.ori	r23,r23,0xa99f
+	
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.muli	r20,r21,0x11
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 2.4 */
+
+	l.addi	r22,r0,-1
+	l.movhi r23,0x2152
+	l.ori	r23,r23,0x4151
+
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+/*
+	l.muli	r20,r21,-1
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+*/
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+
+	/* Test 2.5 */
+
+	l.addi	r22,r0,-2
+
+	l.movhi r23,0x42a4
+	l.ori	r23,r23,0x82a2
+
+	l.mul	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+/*
+	l.muli	r20,r21,-2
+			
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+*/
+	l.mulu	r20,r21,r22
+		
+	l.sfeq	r20,r23
+	l.bnf	_asm_017_mul_ko
+	l.nop	1
+	
+_asm_017_mul_ok :	
+	l.addi	r11,r0,1
+_asm_017_mul_ko :
+	
+	/* load context */
+	l.lwz	r20,0 (r1)
+	l.lwz	r21,4 (r1)	
+	l.lwz	r22,8 (r1)
+	l.lwz	r23,12(r1)
+	l.jr	r9
+	l.addi	r1,r1,16
Index: /trunk/Softwares/Basic_test/src/c/bottles.c
===================================================================
--- /trunk/Softwares/Basic_test/src/c/bottles.c	(revision 88)
+++ /trunk/Softwares/Basic_test/src/c/bottles.c	(revision 88)
@@ -0,0 +1,37 @@
+/*
+ * 99 bottles of beer in ansi c
+ *
+ * by Bill Wein: bearheart@bearnet.com
+ *
+ */
+#include "bottles.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+void chug(int beers);
+
+void bottles(int nb_beers)
+{
+  register int beers;
+
+  for(beers = nb_beers; beers; chug(beers--))
+    puts("");
+  
+  puts("\nTime to buy more beer!\n");
+}
+
+void chug(register int beers)
+{
+  char howmany[8], *s;
+  
+  s = beers != 1 ? "s" : "";
+  printf("%d bottle%s of beer on the wall,\n", beers, s);
+  printf("%d bottle%s of beeeeer . . . ,\n", beers, s);
+  printf("Take one down, pass it around,\n");
+  
+  if(--beers) sprintf(howmany, "%d", beers); else strcpy(howmany, "No more");
+  s = beers != 1 ? "s" : "";
+  
+  printf("%s bottle%s of beer on the wall.\n", howmany, s);
+}
